# Update Webhook subscriptions

> Source: https://truto.one/docs/api-reference/unified-file-storage-api/webhooksubscriptions/update/

`PATCH /unified/file-storage/webhook-subscriptions/{id}`

Resource: **WebhookSubscriptions** · API: **Unified File Storage API**

## Supported integrations

Box, SharePoint

## Path parameters

- **`id`** _(string, required)_
  The ID of the resource.

## Query parameters

- **`integrated_account_id`** _(string, required)_
  The ID of the integrated account to use for the request.
- **`truto_response_format`** _(string)_
  The format of the response. - `unified` returns the response with unified mappings applied. - `raw` returns the unprocessed, raw response from the remote API. - `normalized` applies the unified mappings and returns the data in a normalized format. - `stream` returns the response as a stream, which is ideal for transmitting large datasets, files, or binary data. Using streaming mode helps to efficiently handle large payloads or real-time data flows without requiring the entire data to be buffered in memory. - `debug` returns the final unified result alongside raw remote fetch information. The response is an envelope containing `result` (identical to unified mode output) and `debug` (with `requestUrl`, `requestOptions`, `data`, `responseHeaders`, and for list operations: `nextCursor`, `isLooping`, `isEmptyResult`, `resultCount`). `debug` is `null` for static responses or when `truto_skip_api_call=true`. Defaults to `unified`.
  Allowed: `unified`, `raw`, `normalized`, `stream`, `debug`
- **`truto_ignore_remote_data`** _(boolean)_
  Excludes the `remote_data` attribute from the response.
- **`truto_exclude_fields`** _(array<string>)_
  Array of fields to exclude from the response.
- **`remote_query`** _(object)_
  Query parameters to pass to the underlying API without any transformations. Refer [this guide](https://truto.one/docs/api-reference/overview/querying#remote-query-parameters) to see how to structure the query parameters.

## Request body

- **`notification_url`** _(string, required)_
  A replacement notification URL
- **`resource`** _(object)_
  A replacement Box file or folder target
  - **`id`** _(string, required)_
    The Box file or folder ID
  - **`type`** _(string, required)_
    The resource type
    Allowed: `drive`, `folder`, `file`, `root`, `changes`, `file`, `folder`
- **`change_types`** _(array<string>)_
  Replacement normalized change types
- **`expiration`** _(string)_
  New expiration datetime (ISO 8601, max 30 days from now)
- **`remote_data`** _(object)_
  Any additional data that should be passed as part of the request body. This data is not transformed by Truto and is passed as is to the remote API.

## Response body

- **`id`** _(string, required)_
  The unique identifier for the webhook subscription
- **`type`** _(string)_
  The type of subscription
  Allowed: `webhook`, `web_hook`
- **`notification_url`** _(string, required)_
  The URL where notifications will be sent
- **`resource_id`** _(string)_
  Provider-generated identifier for the watched resource
- **`resource_uri`** _(string)_
  The URI of the resource being watched
- **`change_types`** _(array<string>)_
  Types of changes to monitor
- **`expiration`** _(string)_
  When the subscription expires (ISO 8601 datetime)
- **`client_state`** _(string)_
  Optional secret for verifying webhook authenticity
- **`token`** _(string)_
  Optional token sent with notifications
- **`resource`** _(object)_
  The resource being monitored
  - **`id`** _(string)_
    ID of the resource (drive, folder, etc.)
  - **`type`** _(string)_
    Type of resource
    Allowed: `drive`, `folder`, `file`, `root`, `changes`
- **`drive`** _(object)_
  The drive being monitored
  - **`id`** _(string)_
    The unique identifier for a drive
- **`page_token`** _(string)_
  Starting page token for change notifications (Google Drive only)
- **`created_at`** _(string)_
  When the subscription was created
- **`remote_data`** _(object)_
  Raw data returned from the remote API call.

## Code examples

### Truto CLI

```bash
truto unified file-storage webhooksubscriptions '<resource_id>' \
  -m update \
  -a '<integrated_account_id>' \
  -b '{
  "notification_url": "your_notification_url",
  "resource": {},
  "change_types": [],
  "expiration": "your_expiration",
  "remote_data": {}
}' \
  -o json
```

### Truto TS SDK

```typescript
import Truto from '@truto/truto-ts-sdk';

const truto = new Truto({
  token: '<your_api_token>',
});

const result = await truto.unifiedApi.update(
  'file-storage',
  'webhooksubscriptions',
  '<resource_id>',
  {
  "notification_url": "your_notification_url",
  "resource": {},
  "change_types": [],
  "expiration": "your_expiration",
  "remote_data": {}
},
  { integrated_account_id: '<integrated_account_id>' }
);

console.log(result);
```

### Truto Python SDK

```python
import asyncio
from truto_python_sdk import TrutoApi

truto_api = TrutoApi(token="<your_api_token>")

async def main():
    result = await truto_api.unified_api.update(
        "file-storage",
        "webhooksubscriptions",
        "<resource_id>",
        {
        "notification_url": "your_notification_url",
        "resource": {},
        "change_types": [],
        "expiration": "your_expiration",
        "remote_data": {}
},
        {"integrated_account_id": "<integrated_account_id>"}
    )
    print(result)

asyncio.run(main())
```

### curl

```bash
curl -X PATCH 'https://api.truto.one/unified/file-storage/webhook-subscriptions/{id}?integrated_account_id=<integrated_account_id>' \
  -H 'Authorization: Bearer <your_api_token>' \
  -H 'Content-Type: application/json' \
  -d '{
  "notification_url": "your_notification_url",
  "resource": {},
  "change_types": [],
  "expiration": "your_expiration",
  "remote_data": {}
}'
```

### JavaScript

```javascript
const integratedAccountId = '<integrated_account_id>';

const body = {
  "notification_url": "your_notification_url",
  "resource": {},
  "change_types": [],
  "expiration": "your_expiration",
  "remote_data": {}
};

const response = await fetch(`https://api.truto.one/unified/file-storage/webhook-subscriptions/{id}?integrated_account_id=${integratedAccountId}`, {
  method: 'PATCH',
  headers: {
    'Authorization': 'Bearer <your_api_token>',
    'Content-Type': 'application/json',
  },
  body: JSON.stringify(body),
});

const data = await response.json();
console.log(data);
```

### Python

```python
import requests

url = "https://api.truto.one/unified/file-storage/webhook-subscriptions/{id}"
headers = {
    "Authorization": "Bearer <your_api_token>",
    "Content-Type": "application/json",
}
params = {
    "integrated_account_id": "<integrated_account_id>"
}
payload = {
    "notification_url": "your_notification_url",
    "resource": {},
    "change_types": [],
    "expiration": "your_expiration",
    "remote_data": {}
}

response = requests.patch(url, headers=headers, params=params, json=payload)
print(response.json())
```
